config/routes.rb
Rails.application.routes.draw do
  root 'dashboards#index'
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  resources :projects, only: [:new, :create] do
    get :stats, on: :collection
  end
  resources :tasks, only: [:new, :create, :index ,:edit, :update]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/project.rb
class Project < ApplicationRecord
  has_many :tasks
  belongs_to :manager, class_name: "User"
  has_many :project_developers
  has_many :users, through: :project_developers

  validates_presence_of :name
end

app/models/project_developer.rb
class ProjectDeveloper < ApplicationRecord
  belongs_to :project
  belongs_to :user
end

app/models/task.rb
class Task < ApplicationRecord
  belongs_to :project
  belongs_to :user, optional: true
  validates_presence_of :name
  validates_presence_of :project_id

  scope :with_status, -> (status) { where(status: status) }
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_many :projects, foreign_key: 'manager_id'
  has_many :tasks
  has_many :users, through: :projects

  alias_attribute :project_developers, :users

  scope :developers, -> { where(user_type: "developer") }

  ['manager', 'developer'].each do |user_type|

    method_name = "#{user_type}?"
    define_method(method_name.to_sym) do
      self.user_type == user_type
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  include Pundit
  protect_from_forgery
  before_action :authenticate_user!

  rescue_from Pundit::NotAuthorizedError, with: :user_not_authorized
  rescue_from ActiveRecord::RecordNotFound, with: :not_found

  private

  def user_not_authorized
    redirect_to '/', alert: "User not authorized."
  end

  def not_found
    redirect_to '/', alert: "Record not found."
  end
end

app/controllers/dashboards_controller.rb
class DashboardsController < ApplicationController
  def index
    redirect_to tasks_path unless current_user.manager?

    tasks = Task.select('tasks.name as name, tasks.id as id,
                         tasks.status,
                         projects.name as project_name,
                         projects.id as project_id,
                         users.id as user_id, users.name as user_name')
                .joins(:user, :project)
    @status_hash = {done: "Done", in_progress: "In progress", new: "New"}
    @developer_tasks = {}
    @project_tasks = {}
    tasks.each do |task|
      @developer_tasks[task.user_id] = {"done" => [], "in_progress" => [], "new" => [], "name" => task.user_name} unless @developer_tasks[task.user_id]
      @developer_tasks[task.user_id][task.status] << task
      @project_tasks[task.project_id] = {"done" => [], "in_progress" => [], "new" => [], "name" => task.project_name} unless @project_tasks[task.project_id]
      @project_tasks[task.project_id][task.status] << task
    end
  end
end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  def new
    authorize :project

    @project = Project.new
    @developers = User.developers
  end

  def create
    authorize :project

    @project = Project.new(project_params.merge!(manager_id: current_user.id))
    if @project.save
      redirect_to '/', notice: "Project Created successfully."
    else
      @developers = User.developers
      flash.now[:error] = "Unable to create project."
      render :new
    end
  end

  def stats
    stats = Project.select('COUNT(tasks.id) as count, tasks.status').joins(:tasks).group('tasks.status')
    stats_array = stats.map{|stat| [stat.status.humanize, stat.count]}

    render json: stats_array
  end

  private

  def project_params
    params.require(:project).permit(:name, :user_ids)
  end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: [:edit, :update]

  def index
    authorize :task

    @tasks = TaskPolicy::Scope.new(pundit_user, "Task").resolve
  end

  def new
    authorize :task

    @task = Task.new
    @developers = User.developers
    @projects = Project.all
  end

  def create
    authorize :task

    task = Task.new(task_params.merge!(status: 'new'))
    if task.save
      redirect_to tasks_path, notice: "Task Created successfully."
    else
      @developers = User.developers
      @projects = Project.all
      flash.now[:error] = "Unable to create task."
      render :new
    end
  end

  def edit
    authorize @task

    @developers = User.developers
    @projects = Project.all
  end

  def update
    authorize @task
    if @task.update_attributes(task_params)
      redirect_to tasks_path, notice: "Task updated successfully."
    else
      @developers = User.developers
      @projects = Project.all
      flash.now[:error] = "Unable to update task."
      render :new
    end
  end

  private

  def set_task
    @task = Task.find(params[:id])
  end

  def task_params
    params.require(:task).permit(policy(Task).permitted_attributes)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/dashboards_helper.rb
module DashboardsHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/dashboards/index.html.erb
<!-- <h2> Welcome to dashboard <b><%= current_user&.email %></b> </h1>
 --><%#= link_to 'Create Project', new_project_path%>
<%#= link_to 'Create Task', new_task_path%>

<% if current_user.manager? %>

<% else %>
<% end %>
<h3>Projects</h3>

<div>
  <h3>1. Developer wise task Details</h3>

  <table border=1>
    <thead>
      <th>
        Status
      </th>
      <% @developer_tasks.each do |key, val| %>
        <th>
          <%= "#{val['name']}" %>
        </th>
      <%end%>
    </thead>
    <tbody>
      <% @status_hash.each do |status, status_val| %>
        <tr>
          <th>
            <%= status_val %>
          </th>
          <% @developer_tasks.each do |key, val|%>
            <td>
              <% val[status.to_s].each do |task|%>
                <div>
                  <%= link_to task.name, edit_task_path(task) %>
                </div>
              <% end %>
            </td>
          <% end %>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>

<div>
  <h3>2. Project wise task Details</h3>

  <table border=1>
    <thead>
      <th>
        Status
      </th>
      <% @project_tasks.each do |key, val| %>
        <th>
          <%= "#{val['name']}" %>
        </th>
      <%end%>
    </thead>
    <tbody>
      <% @status_hash.each do |status, status_val| %>
        <tr>
          <th>
            <%= status_val %>
          </th>
          <% @project_tasks.each do |key, val|%>
            <td>
              <% val[status.to_s].each do |task|%>
                <div>
                  <%= link_to task.name, edit_task_path(task) %>
                </div>
              <% end %>
            </td>
          <% end %>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>
<div>
  <h3>3. Pie chart</h3>
  <div id="chart_div"></div>
</div>
<script type="text/javascript">
  $(document).ready(function() {
    google.charts.setOnLoadCallback(loadChart);
  });
</script>

app/views/layouts/_header_menu.html.erb
<table border=1>
  <thead>
    <th><%= link_to "Home", '/' %></th>
    <% if current_user.manager? %>
      <th><%= link_to 'Create Project', new_project_path%></th>
      <th><%= link_to 'Create Task', new_task_path%></th>
    <% end %>
    <th><%= link_to 'Logout', destroy_user_session_path, method: :delete%></th>
    <%= current_user&.email %>
  </thead>
</table>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TodoApp</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>

    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
    <script type="text/javascript">

      // Load the Visualization API and the corechart package.
      google.charts.load('current', {'packages':['corechart']});


    </script>

  </head>

  <body>
    <%= render 'layouts/header_menu' if user_signed_in? %>
    <% flash.each do |name, msg| -%>
      <%= content_tag :div, msg, class: name %>
    <% end -%>

  </body>
    <%= yield %>
  </body>
</html>

app/views/projects/new.html.erb
<h3>Create Project</h3>

<%= form_for @project do |f| %>
  Name: <%= f.text_field :name %><br />
  Developers: <%= f.select(:user_ids, options_for_select(@developers.collect{|d| [ d.name, d.id ]}), {include_blank: false}, multiple: true) %><br />
  <%= f.submit %>
<% end %>

app/views/tasks/edit.html.erb
<h3>Edit task</h3>

<%= form_for @task do |f| %>
  Name: <%= f.text_field :name, disabled: ! current_user.manager? %><br />
  Project: <%= f.select(:project_id, options_for_select(@projects.collect{|d| [ d.name, d.id ]}, selected: @task.project_id), {include_blank: false}, disabled: ! current_user.manager?) %><br />
  Developer: <%= f.select(:user_id, options_for_select(@developers.collect{|d| [ d.name, d.id ]}, selected: @task.user_id), {include_blank: false}, disabled: ! current_user.manager?) %><br />
  Status: <%= f.select(:status, options_for_select({"New" => 'new', "In progress" => 'in_progress', "Done" => 'done'}, selected: @task.status, disabled: 'new'), {include_blank: false}) %><br />
  <%= f.submit %>
<% end %>

app/views/tasks/index.html.erb
<h3>Tasks list</h3>

<table border=1>
  <thead>
    <th>
      Name
    </th>
    <th>
      Status
    </th>
  </thead>
  <tbody>
    <% @tasks.each do |task| %>
      <tr>
        <td><%= link_to task.name, edit_task_path(task) %></td>
        <td> <%= task.status.humanize %> </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/tasks/new.html.erb
<h3>Create task</h3>

<%= form_for @task do |f| %>
  Name: <%= f.text_field :name %><br />
  Project: <%= f.select(:project_id, options_for_select(@projects.collect{|d| [ d.name, d.id ]}), {include_blank: false}) %><br />
  Developer: <%= f.select(:user_id, options_for_select(@developers.collect{|d| [ d.name, d.id ]}), {include_blank: false}) %><br />
  <%= f.submit %>
<% end %>